	.module Wasp_SPI_Flash.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
	.dbfunc e FlashChipSelect _FlashChipSelect fV
;           mode -> R20
	.even
_FlashChipSelect::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 89
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_SPI_Flash.c	Version: 0.92
;    
;    Author:  SS	  					  Date:  June 11, 2010
;    
;    Compiled with ImageCraft ICCAVR Standard V7.20.
;    
;    The AVR SPI lines are connected to two serial flash devices U2 
;    and U5. If the AVR needs to communicate with the Serial 
;    Flash devices the Blackfin must relinquish control of the SPI 
;    lines. 
;    
;    Serial flash devices compatible with the P1 are the AT45DB041
;    (512kx8), AT45DB081 (1Mx8), AT45DB161 (2Mx8), AT45DB321 (4Mx8)
;    or AT45DB642 (8Mx8).
;    
;    The Serial Flash chips are page oriented with 2 SRAM buffers of 264,
;    528 or 1024 bytes each.  The AVR programs the serial flash devices by 
;    loading files via the serial line (in IntelHex32 format) into the RAM 
;    buffers before transfer to the appropriate page.  Page erase/programming 
;    requires about 30msec per page. The routines in this file perform these 
;    functions.  The host terminal program must support XON/XOFF flow control.
;    
;    Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_SPI_Flash.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash Writer, XON/XOFF
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; //*****************************************************
; //*****************************************************
; //  Start Functions
; //*****************************************************
; //*****************************************************
; 
; // Set Serial Flash chip select state
; void FlashChipSelect(unsigned char mode)
; {
	.dbline 90
;      shortdelay(2);
	ldi R16,2
	ldi R17,0
	xcall _shortdelay
	.dbline 91
; 	 if(mode==LOW) PORTB &= 0xEF; 
	cpi R20,2
	brne L2
X0:
	.dbline 91
	in R24,0x5
	andi R24,239
	out 0x5,R24
	xjmp L3
L2:
	.dbline 92
; 	 else PORTB |= 0x10;  
	sbi 0x5,4
L3:
	.dbline 93
;      shortdelay(2);
	ldi R16,2
	ldi R17,0
	xcall _shortdelay
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r mode 20 c
	.dbend
	.dbfunc e ConvertPower2FlashAddress _ConvertPower2FlashAddress fV
;        address -> y+0
	.even
_ConvertPower2FlashAddress::
	xcall push_arg4
	.dbline -1
	.dbline 99
; }
; 
; //  SPI Flash device address construction function
; //  Read address consists of 4 zero bits+11 page bits+8 byte start bits
; void ConvertPower2FlashAddress(long address)
; {
	.dbline 100
;     FlashAddress[0] = (address>>16)&0x00FF;
	ldi R24,255
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	movw R2,R4
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	sts _FlashAddress,R2
	.dbline 101
;     FlashAddress[1] = (address>>8)&0x00FF;
	ldi R24,8
	ldi R25,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R24
	xcall asr32
	movw R2,R16
	movw R4,R18
	ldi R24,255
	ldi R25,0
	ldi R26,0
	ldi R27,0
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	sts _FlashAddress+1,R2
	.dbline 102
;     FlashAddress[2] = address&0x00FF;
	ldi R24,255
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	sts _FlashAddress+2,R2
	.dbline -2
L4:
	.dbline 0 ; func end
	adiw R28,4
	ret
	.dbsym l address 0 L
	.dbend
	.dbfunc e ConvertFlashAddress _ConvertFlashAddress fV
;     superpages -> R10,R11
;      bytestart -> R20,R21
;          pages -> R22,R23
;         inchar -> R10
;        address -> y+6
	.even
_ConvertFlashAddress::
	xcall push_arg4
	xcall push_xgsetF00C
	.dbline -1
	.dbline 108
; }
; 
; //  SPI Flash device address construction function
; //  Read address consists of 4 zero bits+11 page bits+9 byte start bits
; void ConvertFlashAddress(long address)
; {
	.dbline 113
;     unsigned char inchar;
;  	unsigned int pages,bytestart,superpages;
; 	
; 	//  Use simple addressing if 321D or 642D
; 	if((flashpagesize0==256)||(flashpagesize0==512)||(flashpagesize0==1024))  
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	movw R24,R2
	cpi R24,0
	ldi R30,1
	cpc R25,R30
	breq L11
X1:
	cpi R24,0
	ldi R30,2
	cpc R25,R30
	breq L11
X2:
	cpi R24,0
	ldi R30,4
	cpc R25,R30
	brne L8
X3:
L11:
	.dbline 114
; 	                    ConvertPower2FlashAddress(address);
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	xcall _ConvertPower2FlashAddress
	xjmp L9
L8:
	.dbline 115
; 	else {
	.dbline 119
; //	    putchar('=');
; //	    PrintLongHex(address,6);
; //	    putchar(' ');	
; 	    pages = address/flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R22,R16
	.dbline 120
; 	    superpages = pages/256;
	movw R10,R22
	mov R10,R11
	clr R11
	.dbline 121
; 	    bytestart = address - (long)pages*flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	movw R16,R22
	movw R18,R24
	clr R18
	clr R19
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall empy32s
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	sub R2,R16
	sbc R3,R17
	sbc R4,R18
	sbc R5,R19
	movw R20,R2
	.dbline 122
; 	    inchar = ((superpages&0x00ff)<<1) + ((pages&0x00ff)>>7);
	ldi R18,7
	ldi R19,0
	movw R16,R22
	andi R17,0
	xcall lsr16
	movw R24,R10
	andi R25,0
	mov R10,R24
	lsl R10
	rol R11
	add R10,R16
	adc R11,R17
	.dbline 123
;         FlashAddress[0] = inchar;
	sts _FlashAddress,R10
	.dbline 125
; //	    PrintHex(inchar);
; 	    inchar = ((pages&0x00ff)<<1) + (bytestart>>8);
	movw R2,R20
	mov R2,R3
	clr R3
	movw R24,R22
	andi R25,0
	mov R10,R24
	lsl R10
	rol R11
	add R10,R2
	adc R11,R3
	.dbline 126
; 	    FlashAddress[1] = inchar;
	sts _FlashAddress+1,R10
	.dbline 128
; //	    PrintHex(inchar);
; 	    inchar = bytestart & 0x00FF;
	movw R24,R20
	andi R25,0
	mov R10,R24
	.dbline 129
; 	    FlashAddress[2] = inchar;
	sts _FlashAddress+2,R10
	.dbline 132
; //	    PrintHex(inchar);
; //	    putchar('=');	
; 		}
L9:
	.dbline -2
L7:
	.dbline 0 ; func end
	xcall pop_xgsetF00C
	adiw R28,4
	ret
	.dbsym r superpages 10 i
	.dbsym r bytestart 20 i
	.dbsym r pages 22 i
	.dbsym r inchar 10 c
	.dbsym l address 6 L
	.dbend
	.dbfunc e SPI_SerialFlashStatus _SPI_SerialFlashStatus fc
;      instatus2 -> <dead>
;       instatus -> R10
	.even
_SPI_SerialFlashStatus::
	st -y,R10
	.dbline -1
	.dbline 137
; }
; 
; //  Get serial flash chip status
; unsigned char SPI_SerialFlashStatus(void)
; {
	.dbline 141
;  	 unsigned char instatus,instatus2;
; 	 
; 	 //  Set PB4 - Flash CS
; 	 FlashChipSelect(LOW);
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 144
; 
; 	 // Send read status command
;  	 SPI_MasterTransmit(SF_READ_STATUS);
	ldi R16,215
	xcall _SPI_MasterTransmit
	.dbline 146
; 
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	.dbline 147
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R10,R16
	.dbline 150
; 	 
; 	 // Set PB4 high - deselect Flash chip
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 152
; 	 
; 	 return instatus;
	mov R16,R10
	.dbline -2
L14:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym l instatus2 1 c
	.dbsym r instatus 10 c
	.dbend
	.dbfunc e SPI_StartReadFlashPage _SPI_StartReadFlashPage fV
;              i -> R20,R21
;        address -> R10,R11
	.even
_SPI_StartReadFlashPage::
	xcall push_xgset303C
	movw R10,R16
	.dbline -1
	.dbline 158
; }
; 
; //  SPI Flash continuous read command for AT45DB041B
; //  The AT45DB041B has 2048 264byte pages
; void SPI_StartReadFlashPage(unsigned int address)
; {
	.dbline 162
;  	 int i;
; 	 
; 	 // Send Continuous read command
;  	 SPI_MasterTransmit(SF_READ_CONT);
	ldi R16,232
	xcall _SPI_MasterTransmit
	.dbline 165
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	movw R16,R10
	movw R18,R12
	clr R18
	clr R19
	xcall _ConvertFlashAddress
	.dbline 166
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	clr R21
L16:
	.dbline 166
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L17:
	.dbline 166
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 166
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L16
X4:
	.dbline 169
; 	 
; 	 //  32 dummy bits
; 	 for(i=0; i<4; i++)  SPI_MasterTransmit(0x00);
	clr R20
	clr R21
L20:
	.dbline 169
	clr R16
	xcall _SPI_MasterTransmit
L21:
	.dbline 169
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 169
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brlt L20
X5:
	.dbline -2
L15:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r address 10 i
	.dbend
	.dbfunc e SPI_ReadFlashBuffer _SPI_ReadFlashBuffer fV
;              i -> R20,R21
;   buffernumber -> R20,R21
;        address -> R10,R11
	.even
_SPI_ReadFlashBuffer::
	xcall push_xgset303C
	movw R20,R18
	movw R10,R16
	.dbline -1
	.dbline 174
; }
; 
; //  SPI Flash Buffer Read command for AT45DB041B
; void SPI_ReadFlashBuffer(unsigned int address,unsigned int buffernumber)
; {
	.dbline 178
;  	 int i;
; 	 
; 	 // Send buffer read command
; 	 if(buffernumber==1) SPI_MasterTransmit(SF_READ_BUFFER1);
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brne L25
X6:
	.dbline 178
	ldi R16,84
	xcall _SPI_MasterTransmit
	xjmp L26
L25:
	.dbline 179
; 	 else SPI_MasterTransmit(SF_READ_BUFFER2);
	ldi R16,86
	xcall _SPI_MasterTransmit
L26:
	.dbline 182
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	movw R16,R10
	movw R18,R12
	clr R18
	clr R19
	xcall _ConvertFlashAddress
	.dbline 183
; 	 FlashAddress[0] = 0x00;
	clr R2
	sts _FlashAddress,R2
	.dbline 184
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	clr R21
L27:
	.dbline 184
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L28:
	.dbline 184
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 184
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L27
X7:
	.dbline 187
; 	 
; 	 //  8 dummy bits
; 	 SPI_MasterTransmit(0x00);
	clr R16
	xcall _SPI_MasterTransmit
	.dbline -2
L24:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r buffernumber 20 i
	.dbsym r address 10 i
	.dbend
	.dbfunc e DisplaySerialFlash _DisplaySerialFlash fV
;       numlines -> y+5
; bytesonlastline -> y+4
;        linecnt -> y+2
;     newaddress -> R12,R13
;      tempvalue -> R20
;       asciicnt -> y+1
;       crcvalue -> y+0
;           byte -> R22
;              i -> R10
;       readmode -> R20
;       numbytes -> R10,R11
;        address -> y+17
	.even
_DisplaySerialFlash::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,7
	ldd R20,y+21
	.dbline -1
	.dbline 194
; }
; 
; 
; //  Display P1 Blackfin Flash memory
; //    Blackfin must be reset
; void DisplaySerialFlash(unsigned int address,unsigned int numbytes,char readmode)
; {
	.dbline 199
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 //  Set PC4 low - Flash CS
; 	 FlashChipSelect(LOW);  
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 201
; 
; 	 if(readmode==READCONTINUOUS) SPI_StartReadFlashPage(address);
	cpi R20,1
	brne L32
X8:
	.dbline 201
	ldd R16,y+17
	ldd R17,y+18
	xcall _SPI_StartReadFlashPage
	xjmp L33
L32:
	.dbline 202
; 	 else if(readmode==READBUFFER) SPI_ReadFlashBuffer(address,1);
	cpi R20,2
	brne L34
X9:
	.dbline 202
	ldi R18,1
	ldi R19,0
	ldd R16,y+17
	ldd R17,y+18
	xcall _SPI_ReadFlashBuffer
L34:
L33:
	.dbline 203
; 	 puts("Send Continuous Read command\n\r");
	ldi R16,<L36
	ldi R17,>L36
	xcall _puts
	.dbline 204
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+1,R0
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	.dbline 205
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 206
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+6,R17
	std y+5,R16
	.dbline 207
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	movw R2,R10
	sub R2,R16
	sbc R3,R17
	std y+4,R2
	xjmp L38
L37:
	.dbline 208
; 	 while(linecnt<numlines) {
	.dbline 209
; 	 	 crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 210
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 212
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 213
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+0
	clr R5
	add R4,R2
	adc R5,R3
	std y+0,R4
	.dbline 215
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 216
; 	     PrintWordHex(newaddress);
	movw R16,R12
	xcall _PrintWordHex
	.dbline 217
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 218
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 219
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 220
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 222
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L40
	ldi R17,>L40
	xcall _puts
	.dbline 224
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L44
L41:
	.dbline 224
	.dbline 225
; 	         byte = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R22,R16
	.dbline 226
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+1
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 227
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 228
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 229
; 	         }
L42:
	.dbline 224
	inc R10
L44:
	.dbline 224
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L41
X10:
	.dbline 230
; 		 linecnt++;
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 231
; 		 asciicnt = 0;
	clr R0
	std y+1,R0
	.dbline 233
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 234
; 	     puts("  ");
	ldi R16,<L45
	ldi R17,>L45
	xcall _puts
	.dbline 235
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L49
L46:
	.dbline 235
	.dbline 236
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L50
X11:
	mov R24,R14
	cpi R24,128
	brsh L50
X12:
	.dbline 236
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L51
L50:
	.dbline 237
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L51:
	.dbline 238
; 			 }
L47:
	.dbline 235
	inc R10
L49:
	.dbline 235
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L46
X13:
	.dbline 239
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 240
; 		 }
L38:
	.dbline 208
	ldd R0,y+2
	ldd R1,y+3
	ldd R16,y+5
	ldd R17,y+6
	cp R0,R16
	cpc R1,R17
	brge X20
	xjmp L37
X20:
X14:
	.dbline 241
; 	 if(bytesonlastline) {
	ldd R0,y+4
	tst R0
	brne X21
	xjmp L52
X21:
X15:
	.dbline 241
	.dbline 242
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 243
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 245
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 246
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+0
	clr R5
	add R4,R2
	adc R5,R3
	std y+0,R4
	.dbline 248
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 249
; 	     PrintWordHex(newaddress);
	movw R16,R12
	xcall _PrintWordHex
	.dbline 250
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 251
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 252
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 253
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 255
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L40
	ldi R17,>L40
	xcall _puts
	.dbline 257
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L57
L54:
	.dbline 257
	.dbline 258
; 	         byte = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R20,R16
	mov R22,R20
	.dbline 259
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+1
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 260
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 261
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 262
; 	         }
L55:
	.dbline 257
	inc R10
L57:
	.dbline 257
	ldd R0,y+4
	cp R10,R0
	brlo L54
X16:
	.dbline 264
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 265
; 	     puts("  ");
	ldi R16,<L45
	ldi R17,>L45
	xcall _puts
	.dbline 266
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L61
L58:
	.dbline 266
	.dbline 267
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L62
X17:
	cpi R20,128
	brsh L62
X18:
	.dbline 267
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L63
L62:
	.dbline 268
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L63:
	.dbline 269
; 			 }
L59:
	.dbline 266
	inc R10
L61:
	.dbline 266
	ldd R0,y+4
	cp R10,R0
	brlo L58
X19:
	.dbline 270
; 		 putCRLF();
	xcall _putCRLF
	.dbline 273
; 		 
; 		 // Set PC4 high - deselect Flash chip
; 		 FlashChipSelect(HIGH);  
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 274
; 		 }
L52:
	.dbline -2
L31:
	.dbline 0 ; func end
	adiw R28,7
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 5 I
	.dbsym l bytesonlastline 4 c
	.dbsym l linecnt 2 I
	.dbsym r newaddress 12 I
	.dbsym r tempvalue 20 c
	.dbsym l asciicnt 1 c
	.dbsym l crcvalue 0 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r readmode 20 c
	.dbsym r numbytes 10 i
	.dbsym l address 17 i
	.dbend
	.dbfunc e ChipErase _ChipErase fV
;              i -> R20,R21
	.even
_ChipErase::
	xcall push_xgset300C
	.dbline -1
	.dbline 280
; }
; 
; // Execute chip erase - 20 seconds for AT45DB642
; // The chip erase command may not work
; void ChipErase()
; {
	.dbline 283
;     int i;
; 
; 	inteladdress = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	sts _inteladdress+1,R25
	sts _inteladdress,R24
	sts _inteladdress+2+1,R27
	sts _inteladdress+2,R26
	.dbline 284
;  	if(flashtype0==AT45DB081ID) {
	lds R24,_flashtype0
	cpi R24,36
	brne L65
X22:
	.dbline 284
	.dbline 285
; 	    for(i=0; i<4096; i++) {
	clr R20
	clr R21
L67:
	.dbline 285
	.dbline 286
; 		    EraseFlashPage();
	xcall _EraseFlashPage
	.dbline 287
; 	 		WaitForFlashFree();
	xcall _WaitForFlashFree
	.dbline 289
; 			//Delaymsec(32);
; 			inteladdress += 256;
	ldi R24,0
	ldi R25,1
	ldi R26,0
	ldi R27,0
	lds R4,_inteladdress+2
	lds R5,_inteladdress+2+1
	lds R2,_inteladdress
	lds R3,_inteladdress+1
	add R2,R24
	adc R3,R25
	adc R4,R26
	adc R5,R27
	sts _inteladdress+1,R3
	sts _inteladdress,R2
	sts _inteladdress+2+1,R5
	sts _inteladdress+2,R4
	.dbline 290
; 			}
L68:
	.dbline 285
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 285
	cpi R20,0
	ldi R30,16
	cpc R21,R30
	brlt L67
X23:
	.dbline 291
; 		}
	xjmp L66
L65:
	.dbline 292
; 	else if(flashtype0==AT45DB642ID) {
	lds R24,_flashtype0
	cpi R24,60
	brne L71
X24:
	.dbline 292
	.dbline 293
; 	    for(i=0; i<8192; i++) {
	clr R20
	clr R21
L73:
	.dbline 293
	.dbline 294
; 		    EraseFlashPage();
	xcall _EraseFlashPage
	.dbline 295
; 			WaitForFlashFree();
	xcall _WaitForFlashFree
	.dbline 296
; 			inteladdress += 1024;
	ldi R24,0
	ldi R25,4
	ldi R26,0
	ldi R27,0
	lds R4,_inteladdress+2
	lds R5,_inteladdress+2+1
	lds R2,_inteladdress
	lds R3,_inteladdress+1
	add R2,R24
	adc R3,R25
	adc R4,R26
	adc R5,R27
	sts _inteladdress+1,R3
	sts _inteladdress,R2
	sts _inteladdress+2+1,R5
	sts _inteladdress+2,R4
	.dbline 297
; 			}
L74:
	.dbline 293
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 293
	cpi R20,0
	ldi R30,32
	cpc R21,R30
	brlt L73
X25:
	.dbline 298
; 		}
L71:
L66:
	.dbline -2
L64:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 I
	.dbend
	.dbfunc e ProgramBuffertoPageErase _ProgramBuffertoPageErase fV
;              i -> R20
;       bufferid -> R20
	.even
_ProgramBuffertoPageErase::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 318
; 
; /*
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
; 
; 	 // Four byte chip erase sequence
; 	 SPI_MasterTransmit(SF_CHIP_ERASE1);
; 	 SPI_MasterTransmit(SF_CHIP_ERASE2);
; 	 SPI_MasterTransmit(SF_CHIP_ERASE3);
; 	 SPI_MasterTransmit(SF_CHIP_ERASE4);
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(HIGH);   
; */	 
; }
; 
; // Transfer buffer n to flash memory with built-in erase
; //  This operation takes about 20msec max
; void  ProgramBuffertoPageErase(unsigned char bufferid)
; {
	.dbline 322
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 325
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1) SPI_MasterTransmit(SF_BUF1_TO_FLASH_ERASE);
	cpi R20,1
	brne L78
X26:
	.dbline 325
	ldi R16,131
	xcall _SPI_MasterTransmit
	xjmp L79
L78:
	.dbline 326
; 	 else SPI_MasterTransmit(SF_BUF2_TO_FLASH_ERASE);
	ldi R16,134
	xcall _SPI_MasterTransmit
L79:
	.dbline 329
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R18,_inteladdress+2
	lds R19,_inteladdress+2+1
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 331
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L83
L80:
	.dbline 331
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L81:
	.dbline 331
	inc R20
L83:
	.dbline 331
	cpi R20,3
	brlo L80
X27:
	.dbline 334
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(HIGH);   	 
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L77:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e EraseFlashPage _EraseFlashPage fV
;              i -> R20
	.even
_EraseFlashPage::
	st -y,R20
	.dbline -1
	.dbline 339
; }
; 
; // Maximum erase time is 20msec
; void  EraseFlashPage()
; {
	.dbline 343
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 346
; 	 
; 	 //  Buffer write
; 	 SPI_MasterTransmit(SF_PAGE_ERASE);
	ldi R16,129
	xcall _SPI_MasterTransmit
	.dbline 349
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R18,_inteladdress+2
	lds R19,_inteladdress+2+1
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 351
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L88
L85:
	.dbline 351
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L86:
	.dbline 351
	inc R20
L88:
	.dbline 351
	cpi R20,3
	brlo L85
X28:
	.dbline 354
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(HIGH);   	 
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L84:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e ProgramFlashBuffer _ProgramFlashBuffer fV
;              i -> R20
;       bufferid -> R20
	.even
_ProgramFlashBuffer::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 359
; }
; 
; //  Load data into flash chip RAM buffer
; void ProgramFlashBuffer(unsigned char bufferid)
; {
	.dbline 363
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 366
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_WRITE_BUFFER1);
	cpi R20,1
	brne L90
X29:
	.dbline 366
	ldi R16,132
	xcall _SPI_MasterTransmit
	xjmp L91
L90:
	.dbline 367
; 	 else  SPI_MasterTransmit(SF_WRITE_BUFFER2);
	ldi R16,135
	xcall _SPI_MasterTransmit
L91:
	.dbline 370
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R18,_inteladdress+2
	lds R19,_inteladdress+2+1
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 372
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L95
L92:
	.dbline 372
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L93:
	.dbline 372
	inc R20
L95:
	.dbline 372
	cpi R20,3
	brlo L92
X30:
	.dbline 374
; 	 
; 	 for(i=0; i<bytesonline; i++)  SPI_MasterTransmit(intelbinary[i]);
	clr R20
	xjmp L99
L96:
	.dbline 374
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L97:
	.dbline 374
	inc R20
L99:
	.dbline 374
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R20
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L96
X31:
	.dbline 377
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L89:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e LoadFlashPage _LoadFlashPage fV
;              i -> R20
;       bufferid -> R20
	.even
_LoadFlashPage::
	xcall push_xgset300C
	mov R20,R16
	.dbline -1
	.dbline 381
; }
; 
; void LoadFlashPage(unsigned char bufferid)
; {
	.dbline 385
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 388
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_FLASH_TO_BUF1);
	cpi R20,1
	brne L101
X32:
	.dbline 388
	ldi R16,83
	xcall _SPI_MasterTransmit
	xjmp L102
L101:
	.dbline 389
; 	 else  SPI_MasterTransmit(SF_FLASH_TO_BUF2);
	ldi R16,85
	xcall _SPI_MasterTransmit
L102:
	.dbline 392
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R18,_inteladdress+2
	lds R19,_inteladdress+2+1
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	xcall _ConvertFlashAddress
	.dbline 394
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	clr R20
	xjmp L106
L103:
	.dbline 394
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _SPI_MasterTransmit
L104:
	.dbline 394
	inc R20
L106:
	.dbline 394
	cpi R20,3
	brlo L103
X33:
	.dbline 397
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline -2
L100:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e WaitForFlashFree _WaitForFlashFree fV
	.even
_WaitForFlashFree::
	.dbline -1
	.dbline 402
;     
; }
; 
; void  WaitForFlashFree(void)
; { 	  
L108:
	.dbline 403
; 	  while(!(SPI_SerialFlashStatus()&0x80)) ;
L109:
	.dbline 403
	xcall _SPI_SerialFlashStatus
	sbrs R16,7
	rjmp L108
X34:
	.dbline -2
L107:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramSerialFlash _ProgramSerialFlash fV
;   shortbytecnt -> R10,R11
;   shortaddress -> y+4
;       newpage2 -> R12,R13
;        newpage -> R10,R11
;  globaladdress -> y+0
; firstbytesonline -> R14,R15
;     newbytecnt -> y+8
;              i -> R12,R13
	.even
_ProgramSerialFlash::
	xcall push_xgsetF0FC
	sbiw R28,10
	.dbline -1
	.dbline 424
; }
; 
; //  Main Serial Flash programming state controller
; //
; //  Serial flash chips are programmed one page at a time.  Each flash chip
; //  has two SRAM buffers.  Due to AVR limitations programming data is first
; //  loaded into the SRAM buffers then transferred to Flash.  SRAM buffers 
; //  range in size from 264 to 1024 bytes so the state machine must keep track
; //  of different buffer sizes.  IntelHex records range in size from 1 to 32
; //  bytes (AVR limitation) and can arrive at any start address.
; //
; //  As IntelHex records are received on the serial channel they are first
; //  loaded into Flash SRAM (AVR doesn't have enough SRAM available) and then
; //  written to a Flash page if a termination record is received or the SRAM 
; //  buffer becomes full.  To prevent Flash overwrite a Flash page is first 
; //  loaded into SRAM and new data overwritten in SRAM.  
; //
; //  To reduce variable use bytesonline, inteladdress and intelsuperaddress
; //  are global variables.
; void ProgramSerialFlash(void)
; {
	.dbline 428
;  	 long globaladdress,shortaddress;
; 	 int newpage,newpage2,shortbytecnt,newbytecnt,i,firstbytesonline;
; 	 
; 	 globaladdress = intelsuperaddress*65536 + inteladdress;
	lds R2,_intelsuperaddress
	lds R3,_intelsuperaddress+1
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32s
	movw R2,R16
	movw R4,R18
	lds R8,_inteladdress+2
	lds R9,_inteladdress+2+1
	lds R6,_inteladdress
	lds R7,_inteladdress+1
	add R2,R6
	adc R3,R7
	adc R4,R8
	adc R5,R9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 429
; 	 newpage = globaladdress/flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R10,R16
	.dbline 430
; 	 oldinteladdress = inteladdress;
	lds R4,_inteladdress+2
	lds R5,_inteladdress+2+1
	lds R2,_inteladdress
	lds R3,_inteladdress+1
	sts _oldinteladdress+1,R3
	sts _oldinteladdress,R2
	sts _oldinteladdress+2+1,R5
	sts _oldinteladdress+2,R4
	.dbline 434
; //	 puts(" ga="); PrintWordHex(inteladdress); putcharr(' ');
; 	 
;      // Always load flash page for first record
;  	 if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L112
X35:
	.dbline 434
	.dbline 435
; 	     totalbytecnt = 0;
	clr R2
	clr R3
	sts _totalbytecnt+1,R3
	sts _totalbytecnt,R2
	.dbline 436
; 		 LoadFlashPage(1);
	ldi R16,1
	xcall _LoadFlashPage
	.dbline 437
; 		 WaitForFlashFree();  // wait for page transfer to complete 250usec
	xcall _WaitForFlashFree
	.dbline 438
; 	     flashprogrammingactive = YES;
	ldi R24,1
	sts _flashprogrammingactive,R24
	.dbline 439
; 		 flashpageloaded = YES;
	sts _flashpageloaded,R24
	.dbline 440
; 		 oldpage = newpage;
	sts _oldpage+1,R11
	sts _oldpage,R10
	.dbline 441
; 		 }
	xjmp L113
L112:
	.dbline 445
; 
;  	 // See if flash page was loaded - preserves old data not in the new
; 	 // record from being overwritten
;  	 else if(flashpageloaded==NO)  {
	lds R2,_flashpageloaded
	tst R2
	brne L114
X36:
	.dbline 445
	.dbline 446
; 	     LoadFlashPage(1);
	ldi R16,1
	xcall _LoadFlashPage
	.dbline 447
; 		 WaitForFlashFree();  // wait for programming to complete - 20msec
	xcall _WaitForFlashFree
	.dbline 448
; 		 flashpageloaded = YES;
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 449
; 		 }
L114:
L113:
	.dbline 454
; 		 
; 	 // See if number of bytes in record causes a page boundary traverse
; 	 //  tbd - what if buffer fills exactly?
; //	 newbytecnt = bytesonline;
; 	 newpage2 = (globaladdress+bytesonline)/flashpagesize0;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	add R16,R2
	adc R17,R3
	adc R18,R4
	adc R19,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32s
	movw R12,R16
	.dbline 455
; 	 shortaddress = newpage*flashpagesize0;	 
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R10
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	.dbline 461
; //     if((globaladdress+bytesonline-1)==(shortaddress+flashpagesize0-1)) {
; //	    puts(" yureka ");
; //		printf(" ad=%x ",inteladdress);
; //		}
; 
; 	 if(newpage!=newpage2) {
	cp R10,R12
	cpc R11,R13
	breq L116
X37:
	.dbline 461
	.dbline 462
; 	     flashpageboundarytraversed = YES;
	ldi R24,1
	sts _flashpageboundarytraversed,R24
	.dbline 463
; 	     shortbytecnt = flashpagesize0 - (globaladdress - shortaddress);
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	movw R10,R2
	.dbline 464
; 	     newbytecnt = bytesonline - shortbytecnt;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	sub R2,R10
	sbc R3,R11
	std y+9,R3
	std y+8,R2
	.dbline 466
; //		 printf(" ad=%x ",inteladdress);
; 		 firstbytesonline = bytesonline;
	lds R14,_bytesonline
	lds R15,_bytesonline+1
	.dbline 467
; 		 bytesonline = shortbytecnt;
	sts _bytesonline+1,R11
	sts _bytesonline,R10
	.dbline 469
; //		 printf(" sc=%d %d ",shortbytecnt,newbytecnt);
; 		 }
L116:
	.dbline 471
; 	 
; 	 totalbytecnt += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	lds R4,_totalbytecnt
	lds R5,_totalbytecnt+1
	add R4,R2
	adc R5,R3
	sts _totalbytecnt+1,R5
	sts _totalbytecnt,R4
	.dbline 472
; 	 ProgramFlashBuffer(1); 
	ldi R16,1
	xcall _ProgramFlashBuffer
	.dbline 474
; //	 printf(" lb=%d",totalbytecnt); 
; 	 flashdatainbuffer = YES;
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 477
; 	 
; 	 //  If Buffer full or boundary traversed transfer buffer to flash
; 	 if((newbytecnt==0)||(flashpageboundarytraversed==YES))  {
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	brne X38
	tst R1
	breq L120
X38:
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	brne L118
X39:
L120:
	.dbline 477
	.dbline 478
; 	     ProgramBuffertoPageErase(1);
	ldi R16,1
	xcall _ProgramBuffertoPageErase
	.dbline 479
; 		 WaitForFlashFree();  // wait for programming to complete - 20msec
	xcall _WaitForFlashFree
	.dbline 480
; 		 flashpageloaded = NO;
	clr R2
	sts _flashpageloaded,R2
	.dbline 481
; 		 flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 483
; //		 printf(" fp=%d",newpage); 
; 		 }
L118:
	.dbline 486
; 	 
; 	 //  If record caused a page boundary traversal load next page
; 	 if(flashpageboundarytraversed==YES) {
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	breq X42
	xjmp L121
X42:
X40:
	.dbline 486
	.dbline 488
; 	     //newpage++;       // goto next page
; 		 oldpage = newpage2;
	sts _oldpage+1,R13
	sts _oldpage,R12
	.dbline 490
; //		 printf(" tp=%d ",newpage);
; 		 inteladdress = newpage2*flashpagesize0;  // start address at page bdry
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R12
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	sts _inteladdress+1,R3
	sts _inteladdress,R2
	sts _inteladdress+2+1,R5
	sts _inteladdress+2,R4
	.dbline 491
; 	 	 oldinteladdress = inteladdress;
	sts _oldinteladdress+1,R3
	sts _oldinteladdress,R2
	sts _oldinteladdress+2+1,R5
	sts _oldinteladdress+2,R4
	.dbline 492
; 		 LoadFlashPage(1);   // Load the new page - this may be last record
	ldi R16,1
	xcall _LoadFlashPage
	.dbline 494
; 		                     // So don't overwrite remaining content in page
; 		 WaitForFlashFree();  // wait for page transfer to complete 250usec
	xcall _WaitForFlashFree
	.dbline 495
; 		 flashpageloaded = YES;  // Page loaded so don't do it again next recrd
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 496
; 		 for(i=0; i<newbytecnt; i++)  // Shift record data to start
	clr R12
	clr R13
	xjmp L126
L123:
	.dbline 497
; 		      intelbinary[i] = intelbinary[firstbytesonline-newbytecnt+i];
	movw R30,R14
	ldd R0,y+8
	ldd R1,y+9
	sub R30,R0
	sbc R31,R1
	add R30,R12
	adc R31,R13
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	movw R30,R12
	add R30,R24
	adc R31,R25
	std z+0,R2
L124:
	.dbline 496
	movw R24,R12
	adiw R24,1
	movw R12,R24
L126:
	.dbline 496
	ldd R0,y+8
	ldd R1,y+9
	cp R12,R0
	cpc R13,R1
	brlt L123
X41:
	.dbline 498
; 		 bytesonline = newbytecnt;  // Only write new data in record
	sts _bytesonline+1,R1
	sts _bytesonline,R0
	.dbline 500
; //		 printf(" newcnt=",newbytecnt);
; 		 ProgramFlashBuffer(1);  // write remaining record to RAM buffer
	ldi R16,1
	xcall _ProgramFlashBuffer
	.dbline 501
; 		 flashdatainbuffer = YES;
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 502
; 		 totalbytecnt += newbytecnt;
	lds R2,_totalbytecnt
	lds R3,_totalbytecnt+1
	ldd R0,y+8
	ldd R1,y+9
	add R2,R0
	adc R3,R1
	sts _totalbytecnt+1,R3
	sts _totalbytecnt,R2
	.dbline 503
; 		 flashpageboundarytraversed=NO;
	clr R2
	sts _flashpageboundarytraversed,R2
	.dbline 504
; 	     }
L121:
	.dbline -2
L111:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
	.dbsym r shortbytecnt 10 I
	.dbsym l shortaddress 4 L
	.dbsym r newpage2 12 I
	.dbsym r newpage 10 I
	.dbsym l globaladdress 0 L
	.dbsym r firstbytesonline 14 I
	.dbsym l newbytecnt 8 I
	.dbsym r i 12 I
	.dbend
	.dbfunc e ProgramPower2 _ProgramPower2 fV
	.even
_ProgramPower2::
	.dbline -1
	.dbline 513
; }
; 
; //  Convert Serial Flash to Power of 2 device
; //  For AT45DB642D  - send 3D 2A 80 A6
; //  For AT45DB321D  - send 3D 2A 80 A6
; //  For AT45DB081D  - send 3D 2A 80 A6
; //  Function assumes Serial Flash is 642,321 or 081D
; void ProgramPower2()
; {
	.dbline 515
; 	 //  Set PC4 or PD2 low - Flash CS
; 	 FlashChipSelect(LOW);
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 518
; 
; 	 // Send Power of 2 command sequence
;  	 SPI_MasterTransmit(0x3D);
	ldi R16,61
	xcall _SPI_MasterTransmit
	.dbline 519
;  	 SPI_MasterTransmit(0x2A);
	ldi R16,42
	xcall _SPI_MasterTransmit
	.dbline 520
;  	 SPI_MasterTransmit(0x80);
	ldi R16,128
	xcall _SPI_MasterTransmit
	.dbline 521
;  	 SPI_MasterTransmit(0xA6);
	ldi R16,166
	xcall _SPI_MasterTransmit
	.dbline 524
; 
; 	 // Set PC4 or PD2 high - deselect Flash chip
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 526
; 	 
; 	 Delaymsec(30);
	ldi R16,30
	ldi R17,0
	xcall _Delaymsec
	.dbline -2
L127:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SPI_GetManufacturerID _SPI_GetManufacturerID fc
;      instatus2 -> R10
;       instatus -> R12
;           mode -> R20
	.even
_SPI_GetManufacturerID::
	xcall push_xgset30FC
	mov R20,R16
	.dbline -1
	.dbline 531
; }
; 
; //  Get serial flash chip status
; unsigned char SPI_GetManufacturerID(char mode)
; {
	.dbline 535
;  	 unsigned char instatus,instatus2;
; 	 
; 	 //  Set PC4 or PD2 low - Flash CS
; 	 FlashChipSelect(LOW);
	ldi R16,2
	xcall _FlashChipSelect
	.dbline 538
; 
; 	 // Send Continuous read command
;  	 SPI_MasterTransmit(0x9F);
	ldi R16,159
	xcall _SPI_MasterTransmit
	.dbline 540
; 
; 	 instatus2 = 0x00;
	clr R10
	.dbline 541
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R12,R16
	.dbline 542
; 	 if(mode==1)  printf("Device Id = %x ",instatus);
	cpi R20,1
	brne L129
X43:
	.dbline 542
	mov R18,R12
	clr R19
	ldi R16,<L131
	ldi R17,>L131
	xcall _printf
L129:
	.dbline 543
; 	 instatus2 = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R10,R16
	.dbline 544
; 	 if(mode==1)  	 printf("%x ",instatus2);
	cpi R20,1
	brne L132
X44:
	.dbline 544
	mov R18,R10
	clr R19
	ldi R16,<L134
	ldi R17,>L134
	xcall _printf
L132:
	.dbline 545
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R14,R16
	mov R12,R14
	.dbline 546
; 	 if(mode==1)  	 printf("%x ",instatus);
	cpi R20,1
	brne L135
X45:
	.dbline 546
	mov R18,R12
	clr R19
	ldi R16,<L134
	ldi R17,>L134
	xcall _printf
L135:
	.dbline 547
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R14,R16
	mov R12,R14
	.dbline 548
; 	 if(mode==1)  	 printf("%x\n\r",instatus);
	cpi R20,1
	brne L137
X46:
	.dbline 548
	mov R18,R12
	clr R19
	ldi R16,<L139
	ldi R17,>L139
	xcall _printf
L137:
	.dbline 549
; 	 instatus = SPI_MasterReceive();
	xcall _SPI_MasterReceive
	mov R14,R16
	mov R12,R14
	.dbline 552
; 	 
; 	 // Set PC4 or PD2 high - deselect Flash chip
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	xcall _FlashChipSelect
	.dbline 554
; 	 
; 	 return instatus2;
	mov R16,R10
	.dbline -2
L128:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
	.dbsym r instatus2 10 c
	.dbsym r instatus 12 c
	.dbsym r mode 20 c
	.dbend
	.dbfunc e FlashPageSize _FlashPageSize fI
;       sizecode -> R16
	.even
_FlashPageSize::
	.dbline -1
	.dbline 559
; }
; 
; // Return Serial Flash page size
; int FlashPageSize(unsigned char sizecode)
; {
	.dbline 560
;  	 if((sizecode==AT45DB041ID)||(sizecode==AT45DB081ID))  return 256;
	cpi R16,28
	breq L143
X47:
	cpi R16,36
	brne L141
X48:
L143:
	.dbline 560
	ldi R16,256
	ldi R17,1
	xjmp L140
L141:
	.dbline 561
; 	 else if((sizecode==AT45DB161ID)||(sizecode==AT45DB321ID)) return 512;
	cpi R16,44
	breq L146
X49:
	cpi R16,52
	brne L144
X50:
L146:
	.dbline 561
	ldi R16,512
	ldi R17,2
	xjmp L140
L144:
	.dbline 562
; 	 else if(sizecode==AT45DB642ID) return 1024;
	cpi R16,60
	brne L147
X51:
	.dbline 562
	ldi R16,1024
	ldi R17,4
	xjmp L140
L147:
	.dbline 563
; 	 else  return 0;
	clr R16
	clr R17
	.dbline -2
L140:
	.dbline 0 ; func end
	ret
	.dbsym r sizecode 16 c
	.dbend
	.dbfunc e CheckPower2 _CheckPower2 fV
;         status -> R10
	.even
_CheckPower2::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 567
; }
; 
; void CheckPower2(unsigned char status)
; {
	.dbline 568
;  	 if(status&0x01) return;  // If bit 0 set then Power 2 enabled 
	sbrs R10,0
	rjmp L150
X52:
	.dbline 568
	xjmp L149
L150:
	.dbline 569
; 	 if(((status&0x3C)==AT45DB321ID)||((status&0x3C)==AT45DB642ID)
	mov R24,R10
	clr R25
	andi R24,60
	andi R25,0
	movw R2,R24
	cpi R24,52
	ldi R30,0
	cpc R25,R30
	breq L155
X53:
	cpi R24,60
	ldi R30,0
	cpc R25,R30
	breq L155
X54:
	cpi R24,36
	ldi R30,0
	cpc R25,R30
	brne L152
X55:
L155:
	.dbline 570
; 	    ||((status&0x3C)==AT45DB081ID)) {
	.dbline 571
; 	     printf("Program power 2 in Serial Flash\n\r");
	ldi R16,<L156
	ldi R17,>L156
	xcall _printf
	.dbline 572
; 	     ProgramPower2();
	xcall _ProgramPower2
	.dbline 573
; 		 }
L152:
	.dbline -2
L149:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r status 10 c
	.dbend
	.dbfunc e CheckFlashTypes _CheckFlashTypes fV
	.even
_CheckFlashTypes::
	st -y,R10
	st -y,R11
	.dbline -1
	.dbline 580
; }
; 
; //  Search for serial flash chips U2, U5
; //  U2 is always present while U5 is optional
; //  This routine initializes SPI and resets Blackfin
; void  CheckFlashTypes()
; {
	.dbline 581
; 	Release_SPI();
	xcall _Release_SPI
	.dbline 582
; 	Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 584
; 
; 	SPI_GetManufacturerID(0);
	clr R16
	xcall _SPI_GetManufacturerID
	.dbline 586
; 	
; 	flashtype0 = SPI_SerialFlashStatus();
	xcall _SPI_SerialFlashStatus
	sts _flashtype0,R16
	.dbline 589
; 	
; 	//printf("Flash status = %x\n\r",flashtype0);
; 	if(flashtype0==0xff) flashpagesize0 = 0;
	cpi R16,255
	brne L158
X56:
	.dbline 589
	clr R2
	clr R3
	sts _flashpagesize0+1,R3
	sts _flashpagesize0,R2
	xjmp L159
L158:
	.dbline 590
; 	else {
	.dbline 591
; 		CheckPower2(flashtype0);  // Convert to Power 2
	lds R16,_flashtype0
	xcall _CheckPower2
	.dbline 592
; 	    flashtype0 &= FLASHIDMASK;
	lds R24,_flashtype0
	andi R24,60
	sts _flashtype0,R24
	.dbline 593
; 	    flashpagesize0 = FlashPageSize(flashtype0);
	mov R16,R24
	xcall _FlashPageSize
	sts _flashpagesize0+1,R17
	sts _flashpagesize0,R16
	.dbline 594
; 		}
L159:
	.dbline 596
; 		
; 	printf("Serial flash is ");
	ldi R16,<L160
	ldi R17,>L160
	xcall _printf
	.dbline 597
; 	if(flashtype0==AT45DB041ID) printf("AT45DB041");
	lds R24,_flashtype0
	cpi R24,28
	brne L161
X57:
	.dbline 597
	ldi R16,<L163
	ldi R17,>L163
	xcall _printf
	xjmp L162
L161:
	.dbline 598
; 	else if(flashtype0==AT45DB041ID) printf("AT45DB041 512Kbyte");
	lds R24,_flashtype0
	cpi R24,28
	brne L164
X58:
	.dbline 598
	ldi R16,<L166
	ldi R17,>L166
	xcall _printf
	xjmp L165
L164:
	.dbline 599
; 	else if(flashtype0==AT45DB081ID) printf("AT45DB081D  1Mbyte");
	lds R24,_flashtype0
	cpi R24,36
	brne L167
X59:
	.dbline 599
	ldi R16,<L169
	ldi R17,>L169
	xcall _printf
	xjmp L168
L167:
	.dbline 600
; 	else if(flashtype0==AT45DB161ID) printf("AT45DB161  2Mbyte");
	lds R24,_flashtype0
	cpi R24,44
	brne L170
X60:
	.dbline 600
	ldi R16,<L172
	ldi R17,>L172
	xcall _printf
	xjmp L171
L170:
	.dbline 601
; 	else if(flashtype0==AT45DB321ID) printf("AT45DB321  4Mbyte");
	lds R24,_flashtype0
	cpi R24,52
	brne L173
X61:
	.dbline 601
	ldi R16,<L175
	ldi R17,>L175
	xcall _printf
	xjmp L174
L173:
	.dbline 602
; 	else if(flashtype0==AT45DB642ID) printf("AT45DB642D  8Mbyte");
	lds R24,_flashtype0
	cpi R24,60
	brne L176
X62:
	.dbline 602
	ldi R16,<L178
	ldi R17,>L178
	xcall _printf
	xjmp L177
L176:
	.dbline 603
; 	else printf("not installed");
	ldi R16,<L179
	ldi R17,>L179
	xcall _printf
L177:
L174:
L171:
L168:
L165:
L162:
	.dbline 604
; 	printf("\n\r");
	ldi R16,<L180
	ldi R17,>L180
	xcall _printf
	.dbline 606
; 
; 	flashpagesize0 = FlashPageSize(flashtype0);
	lds R16,_flashtype0
	xcall _FlashPageSize
	movw R10,R16
	sts _flashpagesize0+1,R11
	sts _flashpagesize0,R10
	.dbline 609
; //	printf("flash page size = %d\n\r",flashpagesize0);
; 	
; 	Release_SPI();
	xcall _Release_SPI
	.dbline -2
L157:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L180:
	.blkb 3
	.area idata
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L179:
	.blkb 14
	.area idata
	.byte 'n,'o,'t,32,'i,'n,'s,'t,'a,'l,'l,'e,'d,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L178:
	.blkb 19
	.area idata
	.byte 'A,'T,52,53,'D,'B,54,52,50,'D,32,32,56,'M,'b,'y
	.byte 't,'e,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L175:
	.blkb 18
	.area idata
	.byte 'A,'T,52,53,'D,'B,51,50,49,32,32,52,'M,'b,'y,'t
	.byte 'e,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L172:
	.blkb 18
	.area idata
	.byte 'A,'T,52,53,'D,'B,49,54,49,32,32,50,'M,'b,'y,'t
	.byte 'e,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L169:
	.blkb 19
	.area idata
	.byte 'A,'T,52,53,'D,'B,48,56,49,'D,32,32,49,'M,'b,'y
	.byte 't,'e,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L166:
	.blkb 19
	.area idata
	.byte 'A,'T,52,53,'D,'B,48,52,49,32,53,49,50,'K,'b,'y
	.byte 't,'e,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L163:
	.blkb 10
	.area idata
	.byte 'A,'T,52,53,'D,'B,48,52,49,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L160:
	.blkb 17
	.area idata
	.byte 'S,'e,'r,'i,'a,'l,32,'f,'l,'a,'s,'h,32,'i,'s,32
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L156:
	.blkb 34
	.area idata
	.byte 'P,'r,'o,'g,'r,'a,'m,32,'p,'o,'w,'e,'r,32,50,32
	.byte 'i,'n,32,'S,'e,'r,'i,'a,'l,32,'F,'l,'a,'s,'h,10
	.byte 13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L139:
	.blkb 5
	.area idata
	.byte 37,'x,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L134:
	.blkb 4
	.area idata
	.byte 37,'x,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L131:
	.blkb 16
	.area idata
	.byte 'D,'e,'v,'i,'c,'e,32,'I,'d,32,61,32,37,'x,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L45:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L40:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
L36:
	.blkb 31
	.area idata
	.byte 'S,'e,'n,'d,32,'C,'o,'n,'t,'i,'n,'u,'o,'u,'s,32
	.byte 'R,'e,'a,'d,32,'c,'o,'m,'m,'a,'n,'d,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WASPDA~1.94\Wasp_SPI_Flash.c
; }
; 
; 	
